var total_assignments = 0; //total number of class assignments
var total_students = 0; //total number of students in class
var file_path = "new";
var saving = false;
var t; //timer for autosave

var json = ({
        document_title : "Untitled",
        teacher_name : "Teacher Name",
        
        assignments : new Array(),
        students : new Array(),
        
        history : new Array(), //undo-redo history
        history_index : 0 //position in undo-redo history stack
  });
//json.assignments[0] = ({ date:"1/1/08", abbr:"T1", title:"Test 1", type:"T" });


function fileFormatConverter(info,data)
{
  //File summary
  file_path = info[0][2];
  json = ({
        document_title : info[0][0],
        teacher_name : info[0][1],

        
        assignments : new Array(),
        students : new Array(),
        
        history : new Array(), //undo-redo history
        history_index : 0
  });

  //Assignment info
  for (i=1; i<info.length; i++)
    json.assignments[i-1] = { 
        date : info[i][0],
        abbr : info[i][1],
        title : info[i][2], 
        type : info[i][3],
        max : data[0][i]
    };
  data.shift();
  
  //Student names and points
  for (i=0; i<data.length; i++)
    json.students[i] = { 
        name : data[i].shift(),
        points : data[i]
    }
  
}

window.onunload = function()
{
 if(el("save_button").disabled == false)
 if(!confirm("Are you sure you want to navigate away from this page?\n\nYou have unsaved changes.\n\nPress OK to continue, or Cancel to stay on the current page?") )
   return false;
}

window.onload = function()
{tbegin = new Date();//timer
  notify(); //clear notice about javascript required

  /*globalStorage['localhost'].lastsaved = "testing"*/
  
  /*if (document.cookie) {
    importData(readCookie("Grade_Book"));
  }//notify(JSON.stringify(json.assignments))
  */
  //Cookies disabled until use changes to recent file history instead.
  
  if (document.cookie) file_path = readCookie("Grade_Book"); //reads file path of last open document from cookie
    
  if (file_path == "new") 
    newSheet();
  else if ((output = xpcomFileRead(file_path)))
	  importData(output);
  
  try {
    if (Components) //Check if Components (Mozilla access to file save/open etc.) available.
      if (location.protocol == "file:") {
        saving = true;
      } else {
        el("open_button").disabled = true;
        el("open_button").title = "Only available if Grade Book running from local computer"; //Access to file system disabled
        el("save_as_button").disabled = true;
        el("save_as_button").title = "Only available if Grade Book running from local computer";
      }
  } catch(e) {
    el("open_button").disabled = true;
    el("open_button").title = "Only available for Mozilla-based browsers";
    el("save_as_button").disabled = true;
    el("save_as_button").title = "Only available for Mozilla-based browsers";
  }
  
  if (total_students < 1) notify("Try adding new students first");
  /*
  if(globalStorage.gradebook) {
    alert(globalStorage.gradebook);
  }
  */
  
  // onclick events for buttons above table
  el("gradebook").onsubmit = submitForm;
  el("new_sheet_button").onclick = newSheet;
  el("open_button").onclick = openFile;
  el("save_as_button").onclick = saveAs;
  el("undo_button").onclick = undo;
  el("redo_button").onclick = redo;
  
  // onclick events for assignment headings
  for (var i=0; i < total_assignments; i++)
    el(i).onclick = editAssignmentDialog;
  
  // onclick events for buttons below table
  el("new_assignment_button").onclick = newAssignmentDialog;
  el("new_student_button").onclick = addStudent;
  el("delete_students_button").onclick = deleteStudents;
  
  //keyboard shortcuts
  if (window.event)
    document.onkeydown = keyBindings; //Able to capture ctrl key on IE
  else 
    document.onkeypress = keyBindings;

  //set form elements
	el("sourcecode").value = packageArrays();
  if (json.history_index >= json.history.length) el("undo_button").disabled = true;
  if (json.history_index == 0) el("redo_button").disabled = true;
 
  //start autosave timer
  if (saving) autoSave();
  
  //timer
  tend = new Date();
  notify(tend-tbegin); 
}



function keyBindings(e)
{
  // Get key
  var keynum;
 
  if (window.event) {// IE
    keynum = event.charCode ? event.charCode : event.keyCode;
    e = window.event;
  } else if (e.which) {// Netscape/Firefox/Opera
    keynum = e.which;
  }
  

  var keychar = String.fromCharCode(keynum).toUpperCase();//keypress captures lowercase, keydown uppercase regardless
  //notify(keynum+" "+keychar+" "+e.ctrlKey);
  
  // Key bindings
  if (e.ctrlKey && !e.shiftKey)
  switch (keychar) {
  case "F" :
    notify("f");
    break;
  case "S" :
    submitForm();
    notify("File saved");
    return false;
    break;
  case "O" :
    openFile();
    notify("open");
    return false;
    break;
  case "Z" :
    undo();
    return false;
    break;
  }
}

//adds onchange events for all input boxes within main table
//temp solution until onchange added individually to each new element on addStudent or addAssignment
function updateOnChangeEvents() {
  var table_inputs = el("gradebook").getElementsByTagName("input");
  for (var i=0; i < table_inputs.length; i++) {
    if (table_inputs[i].type == "text") {
      table_inputs[i].onchange = updateDataFromTable;
      if (table_inputs[i].size == 3) {
        table_inputs[i].onfocus = assignmentDetails;
        table_inputs[i].onblur = unhighlightStudent;
      }
    }
  }
  for (var i=0; i < total_assignments; i++)
    el(i).onclick = editAssignmentDialog;
}

function updateDataFromTable()
{
  var id = this.id;
  var tag = id.split("_");
  
  if (tag[1]=="Max") //update to assignment max points
    change("json.assignments["+tag[0]+"].max",this.value,"max score change");
  
  else if (tag[0]=="Student") //update to student name
    change("json.students["+tag[1]+"].name",this.value,"student name change");
  
  else //update to points on a student's assignment
    if (this.value.toUpperCase() == "EXC" || this.value.toUpperCase() == "HID") { // if keyword
      change("json.students["+tag[1]+"].points["+tag[0]+"]",this.value.toUpperCase(),"score change");
      el(this.id).value = this.value.toUpperCase(); //change input to uppercase to indicate recognition of keyword
    } else {
      change("json.students["+tag[1]+"].points["+tag[0]+"]",this.value,"score change");
    }
  
}

function assignmentDetails()
{
  //Post details about particular assignment
  var i = this.id.match(/[0-9]+/)[0];
  notify(json.assignments[i].title + ", " + json.assignments[i].type + " (" + json.assignments[i].date + ")")
  
  //Highlight student
  var i = this.id.match(/_[0-9]+/);
  if (i) el("Student"+i[0]).className = "highlight";
}
function unhighlightStudent()
{
  var i = this.id.match(/_[0-9]+/);
  if (i) el("Student"+i[0]).className = "";
}


function el(id) 
{ 
 if (document.getElementById) { 
   return document.getElementById(id); 
 } else if (window[id]) { 
   return window[id]; }
 return null;
}

//displays messages to user (such as error messages)
function notify(message,permanent)
{
  if (message) {
    el("notice").style.visibility = "visible";
    el("notice").innerHTML = message;
    //if (!permanent) setTimeout("el('notice').style.visibility = 'hidden';",9000);
  } else {
    el("notice").style.visibility = "hidden";
  }
}

function submitForm()
{ 
  save();
  updatePercentages();
  
  return false; //prevents HTML from reloading
}

//Calculates percentages for single student
function updatePercentageFor(j)
{
  var points = 0; //stores running point total for student grade
  var points_Max = 0; //store running point total for student max grade
  
  for (i = 0; i < total_assignments; i++) {
    el(i+"_"+j).className = "";
    
    if (json.students[j].points[i] != "EXC" && json.students[j].points[i] != "HID") {
      points += (json.students[j].points[i] == "") ? 0 : eval(json.students[j].points[i]);
      points_Max += eval(json.assignments[i].max);
      
      //Mark scores above max or empty scores in student points
      if (eval(json.students[j].points[i]) > eval(json.assignments[i].max)) { 
        el(i+"_"+j).className = "extra_credit";
        notify('Star (<img src="./images/star.png" alt="Extra Credit" />) indicates a score higher than max');
      } else if (json.students[j].points[i] == "") {
        el(i+"_"+j).className = "error"; 
        notify('Red mark (<img src="./images/error.png" alt="Error" />) indicates a blank score');
      }
      
      
      // Display errors in assignment max points (no score entered)
      if (json.assignments[i].max == "") el(i+"_Max").className = "error";
      else el(i+"_Max").className = "";
    }
  }
  
  var percent = (points_Max == 0) ? 100 : points / points_Max * 100;
  el("Percent_"+j).innerHTML = Math.round(percent*100)/100 + "%"; //parseInt(percent);    
}

//Calculates percentages for each student and updates display
function updatePercentages()
{
  for (j = 0; j < total_students; j++) updatePercentageFor(j);
}

function packageArrays()
{/*
  var save1 = new Array();
  var save2 = new Array();
  for (i=0; i < data.length; i++) {
    save1[i] = data[i].join("|");
  }
  for (i=0; i < info.length; i++) {
    save2[i] = info[i].join("|");
  }
  return save1.join("\n")+"\n***"+save2.join("\n");*/
  return JSON.stringify(json);
}

function processFile(file)
{  
  if (file.indexOf("\n***")!=-1) {
    var info = [0] //initialize
    var data = [0] //initialize
    file += "";
    var split0 = file.split("\n***");
    var split1 = split0[0].split("\n");
    var split2 = split0[1].split("\n");
    for (i=0; i < split1.length; i++) {
      data[i] = split1[i].split("|");
    }
    for (i=0; i < split2.length; i++) {
      info[i] = split2[i].split("|");
    }
    
    fileFormatConverter(info,data);
  } else {
    json = JSON.parse(file);
    if (!json.history) { json.history = new Array(); json.history_index = 0; }
  }
}


//New default document
function newSheet()
{
  file_path = "new";
  updateCookie(file_path);
  
  json = ({
    "document_title" : "Untitled",
    "teacher_name" : "Teacher Name",
    
    "assignments" : [{
       "date" : "1/1/01",
       "abbr" : "HW",
       "title" : "Sample Homework Assignment",
       "type" : "HW",
       "max" : "20"}],
    
    "students" : [
       {"name":"Student Name 1", "points":["15"]},
       {"name":"Student Name 2", "points":["18"]},
       {"name":"Student Name 3", "points":["20"]},
       {"name":"Student Name 4", "points":["17"]}],
    
    "history" : new Array(),
    "history_index" : 0
  });
  
  el("undo_button").disabled = true;
  el("redo_button").disabled = true;
  importData();
}

function save()
{
  notify() //clear notifications;
  
  el("sourcecode").value = packageArrays();
  //updateCookie(packageArrays()); //file no longer saved to cookie
  
  // Local file save
  xpcomFileWrite(file_path, packageArrays());

  //globalStorage.gradebook = save.join("\n");
  
  el("save_button").disabled = true;
}

//autosave every 30 sec
function autoSave()
{
  if (!el("save_button").disabled) save(); //if any changes then save
  t=setTimeout("autoSave()",30*1000); //30 sec
}

// Make backup copy in case undo is needed
function backupSave()
{
  backup = packageArrays();
  el("undo_button").disabled = false;
  el("redo_button").disabled = true;
}

function importData(file)
{
  if (file=="") { file = "Max|100\nJoe|92\n***Untitled|Teacher Name|C:\\Grade Book\\Untitled.txt\n1/1/08|T1|Test 1|T"; }
  if (file) {
    // Process file
    processFile(file);
  }

  // Add new rows to table if needed
  while (total_students < json.students.length) {
    total_students += 1;
    addRow();
  }
  //Subtract extra rows if needed
  while (total_students > json.students.length) {
    total_students += -1;
    deleteRow();
  }
  
  // Add new columns to table if needed
  while (total_assignments < json.assignments.length) {
    total_assignments += 1;
    addCol();
  }
  while (total_assignments > json.assignments.length) {
    total_assignments += -1
    deleteCol();
  }
  

  // Update max points display
  for (i = 0; i < total_assignments; i++) {
    el(i+"_Max").value = json.assignments[i].max;
  }
  
  // Update student names and student points for each assignment
  for (j = 0; j < total_students; j++) {
    el("Student_"+j).value = json.students[j].name; //stores the sudents name
    for (i = 0; i < total_assignments; i++) {
      el(i+"_"+j).value = json.students[j].points[i]
    }
  }
  
  //Update titles for each assignment
  for (i = 0; i < total_assignments; i++) {
    el(i).innerHTML = json.assignments[i].abbr;
    el(i).title = json.assignments[i].title;
  }
  
  //Caluculations percent for each student and update display
  updatePercentages();
  
  //Update table events
  updateOnChangeEvents();
  
  //Update page title
  document.title = json.document_title + " - Grade Book";
}
    
function addStudent()
{ 
  total_students += 1;
  addRow();
  var older = JSON.stringify(json.students);
  json.students.push({name:"New Student",points:new Array(total_assignments)});
  recordChange("json.students",older,JSON.stringify(json.students),"add student");
  updatePercentages();
  updateOnChangeEvents();
  el("Student_"+(total_students-1)).focus();
  el("Student_"+(total_students-1)).select();
}

function addRow()
{  
  //create new row at end of table
  var new_row = el("gradebooktable").insertRow(-1);
  
  //create student name cell
  var header_cell = document.createElement('th');
  header_cell.className = "student_header";
  new_row.appendChild(header_cell);
  header_cell.innerHTML = '<input type="checkbox" id="Select_' + (total_students-1)
          + '" /><input type="text" value="New Student" id="Student_' + (total_students-1) + '" size="15" tabindex="20" />\n';
  
  //create percent cell
  var new_cell = new_row.insertCell(1);
  new_cell.className = "noedit";
  new_cell.innerHTML = '<span id="Percent_' + (total_students-1) + '">%</span>\n';
  
  //create remaining data cells
  for (i = 0; i < total_assignments; i++) {
    var new_cell = new_row.insertCell(i+2);
    new_cell.innerHTML = '<input type="text" value="" id="' + i + "_" + (total_students-1) + '" size="3" tabindex="'
           + 10*(i+4) + '" />\n';
  }
}

function deleteStudents()
{
  var older = JSON.stringify(json.students); //saved for undo-redo history
  var none_checked = true; //flag
  
  for(i = total_students-1; i >= 0; i--) {
    if (el("Select_"+i).checked) {
      el("Select_"+i).checked = false;
      total_students -= 1;
      json.students.splice(i,1);
      deleteRow();
      none_checked = false;
    }
  }
  
  if (none_checked) {
    notify("No students marked for deletion.\n\nUse checkboxes next to student name to mark for deletion.");
  } else {
    recordChange("json.students",older,JSON.stringify(json.students),"delete students");
    importData();
  }
}

function deleteRow()
{
  el("gradebooktable").deleteRow(-1);
}

function sortStudents()
{
  function sortBy(a,b) {
    if (a.name > b.name) return 1;
    else if (a.name < b.name) return -1;
    else return 0;
  }
  
  var older = JSON.stringify(json.students); //saved for undo-redo history
  
  json.students.sort(sortBy);
  
  recordChange("json.students",older,JSON.stringify(json.students),"sort students");
  importData();
  
  notify("Students sorted by name")
}

function editAssignmentDialog()
{
  var i = this.id;
  el("assignment").getElementsByTagName("h2")[0].innerHTML = 'Edit Assignment '+i;
  el("add_assignment_buttons").style.display = "none";
  el("edit_assignment_buttons").style.display = "block";
  
  el("date").value = json.assignments[i].date;
  el("abbr_title").value = json.assignments[i].abbr;
  el("full_title").value = json.assignments[i].title;
  el("type").value = json.assignments[i].type;
  
  el("assignment").className = "show_dialog";
  el("assignment").onsubmit = editAssignment;
  el("assignment_delete").onclick = deleteAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function editAssignment()
{
  var older = JSON.stringify(json.assignments); //saved for undo-redo history
  var heading = el("assignment").getElementsByTagName("h2")[0].innerHTML
  var i = heading.match(/[0-9]+/);
  json.assignments[i] = {
        date : el("date").value,
        abbr : el("abbr_title").value,
        title : el("full_title").value,
        type : el("type").value,
        max : json.assignments[i].max
  };
  
  recordChange("json.assignments",older,JSON.stringify(json.assignments),"edit assignment details");
  importData();

  el("assignment").className = "hide_dialog"; 
  
  return false; //stops HTML from reloading
}

function newAssignmentDialog()
{
  el("assignment").getElementsByTagName("h2")[0].innerHTML = 'New Assignment';
  el("edit_assignment_buttons").style.display = "none";
  el("add_assignment_buttons").style.display = "block";

  var date = new Date();
  var year = date.getFullYear()+"";
  el("date").value = (date.getMonth()+1) + "/" + date.getDate() + "/" + year.substring(year.length-2,year.length);
  
  el("new_assignment_button").disabled = true;
  el("assignment").className = "show_dialog";
  el("assignment").onsubmit = addAssignment;
  el("abbr_title").focus();
  el("abbr_title").select();
}

function addAssignment()
{
  total_assignments += 1;
  
  var older = JSON.stringify(json.assignments); //saved for undo-redo history
  json.assignments[total_assignments-1] = {
        date : el("date").value,
        abbr : el("abbr_title").value,
        title : el("full_title").value,
        type : el("type").value,
        max : ""
  };
  for (i = 0; i < total_students; i++) {
    json.students[i].points.push("");
  }
  recordChange("json.assignments",older,JSON.stringify(json.assignments),"add assignment");

  addCol()
  importData();
  updateOnChangeEvents();
  
  el("new_assignment_button").disabled = false;
  el("assignment").className = "hide_dialog"; 
  el(total_assignments-1+"_Max").focus();
  el(total_assignments-1+"_Max").select();
  
  return false; //prevents entire page from reloading
}

function addCol()
{
  //create assignment title cell
  var header_cell = document.createElement('th');
  el("gradebooktable").rows[0].appendChild(header_cell);
  header_cell.innerHTML = '<span title="' 
          + json.assignments[total_assignments-1].title + '" id="' + (total_assignments-1)
          + '" tabindex="' + 10*(total_assignments+3) + '">'
          + json.assignments[total_assignments-1].abbr +'</span>\n';
  
  //create max points cell
  var new_cell = el("gradebooktable").rows[1].insertCell(total_assignments+1);
  new_cell.innerHTML = '<input type="text" value="100" id="' + (total_assignments-1) 
          + '_Max" size="3" tabindex="' + 10*(total_assignments+3) + '" />\n';
  
  //create data cells for each student
  for (i = 0; i < total_students; i++) {
    var new_cell = el("gradebooktable").rows[i+2].insertCell(total_assignments+1);
    new_cell.innerHTML = '<input type="text" value="" id="' + (total_assignments-1) + "_" + i
          +'" size="3" tabindex="' + 10*(total_assignments+3) + '" />\n';;
  }
}

function deleteAssignment(i)
{
  var older = JSON.stringify(json.assignments)+"'__m__'"+JSON.stringify(json.students); //multi-statement save for undo-redo history
  
  var heading = el("assignment").getElementsByTagName("h2")[0].innerHTML
  var i = heading.match(/[0-9]+/);
  
  total_assignments -= 1;
  json.assignments.splice(i,1);
  for (var j=0; j<total_students; j++)
    json.students[j].points.splice(i,1);
  deleteCol();
  
  recordChange("json.assignments__m__json.students",older,JSON.stringify(json.assignments)+"'__m__'"+JSON.stringify(json.students),"delete assignment");
  importData();
  
  el('assignment').className = 'hide_dialog';
}

function deleteCol()
{
  //delete last cell from each row
  for (i = 0; i <= total_students+1; i++) {
    el("gradebooktable").rows[i].deleteCell(-1);
  }
}

function fullIndividualReports()
{
  var newHTML  = '<?xml version="1.0" encoding="UTF-8"?>\n'
          + '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"\n'
          + '   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">\n'
          + '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" >\n'
          + '<head><title>' + json.teacher_name + ': ' + json.document_title + '</title>' // Teacher and class name
          + '<style type="text/css">h1 {font-size:1.5em;} th {text-align:left} table {width:100%; border-spacing:0} tr.odd td {border-bottom:.2pt solid grey;} thead th {border-bottom:1pt solid black}</style></head>\n'
          + '<body onload="window.print()">\n';
  
  for (j = 0; j < total_students; j++) {
  
    // Add student name, and table headings
    newHTML  += "\n<h1>" + json.students[j].name + "</h1>\n" // Student name
          + '<table><thead><tr><th>Title</th><th>Type</th><th>Date</th><th>Grade</th></thead></tr>\n'
          + '<tfoot><tr><td colspan="4"><p>'
          + '<small>EXC = Excused; NON = None (assignment not turned in)</small></p></td></tr></tfoot><tbody>';
    
    // Add student data for every assignment 
    var offset = 0;
    for (i = 0; i < total_assignments; i++) {
      var score = json.students[j].points[i];
      if (score == "HID") { 
        offset -= 1; //offset for hidden lines so odd and even rows aren't messed up
      } else { //display assignment since there is no indication to HIDe it
        if (score == "") score = "NON";
        if (score != "EXC") score += " / " + json.assignments[i].max //max points omited if EXCused
        
        if (Math.floor((i+offset)/2) != (i+offset)/2) //index + offset for hidden lines to find if we are on an even or odd row
          newHTML += '<tr class="odd">\n';
        else
          newHTML += '<tr>\n';
        
        newHTML += "<td>" + json.assignments[i].title //full title of assignment
            + "</td>\n<td>" + json.assignments[i].type //type
            + "</td>\n<td>" + json.assignments[i].date //date
            + "</td>\n<td>" + score //grade
            + "</td></tr>\n";
      }
    }
    
    // Calculate letter grade
    var percent = el("Percent_"+j).innerHTML;
    percent = percent.substring(0,percent.length-1);
    var letter = getLetterGrade(percent);
    
    // Add Abbreviation key overall grade
    newHTML += '</tbody></table>\n\n'
          + '<p style="page-break-after:always"><strong>Overall Grade: ' + percent + '% ' + letter + '</strong></p>\n\n';
  }
  newHTML += "</body>\n</html>";
  
  document.writeln(newHTML);
  document.close();
}

function getLetterGrade(percent)
{
  var grade; 
  
  if (percent >= 95) grade = "A"
  else if (percent >= 90) grade = "A-"
  else if (percent >= 87) grade = "B+"
  else if (percent >= 83) grade = "B"
  else if (percent >= 80) grade = "B-"
  else if (percent >= 77) grade = "C+"
  else if (percent >= 73) grade = "C"
  else if (percent >= 70) grade = "C-"
  else if (percent >= 67) grade = "D+"
  else if (percent >= 63) grade = "D"
  else if (percent >= 60) grade = "D-"
  else grade = "F";
  
  return grade;
}

function fileSummaryDialog()
{
  el("class_title").value = json.document_title;
  el("teacher").value = json.teacher_name;
  el("file_save_location").value = file_path;
  el("save_as_button").disabled = true;
  el("file_summary").style.display = "block";
  el("file_summary").onsubmit = saveFileSummary;
  el("class_title").focus();
  el("class_title").select();
}
function saveFileSummary()
{
  var older = JSON.stringify(json); //saved for undo-redo history
  json.document_title = el('class_title').value;
  json.teacher_name = el('teacher').value;
  file_path = el('file_save_location').value;
  recordChange("json",older,JSON.stringify(json),"file summary");
  el("save_as_button").disabled = false;
  el("file_summary").style.display = "none";
    
  return false; //prevents entire page from reloading
}

function showSource()
{
  el("sourcecode_form").style.display = "block";
  el("show_source").innerHTML = "Hide source code";
  el("show_source").href = "javascript:hideSource();";
}
function hideSource()
{
  el("sourcecode_form").style.display = "none";
  el("show_source").innerHTML = "Show source code";
  el("show_source").href = "javascript:showSource();";
}